diff -uwr sourceold/scripts/dp88_ar.h source/scripts/dp88_ar.h
--- sourceold/scripts/dp88_ar.h	2011-12-01 12:10:36.260742100 +0800
+++ source/scripts/dp88_ar.h	2012-05-23 10:33:45.797851500 +0800
@@ -183,12 +183,63 @@
 
 
 
-/*------------------------
-AR Miner Script - Base Class
+// -------------------------------------------------------------------------------------------------
 
-This base class is used by both the dp88_AR_Chrono_Miner and dp88_AR_War_Miner scripts
-and implements common functionality used by both scripts.
---------------------------*/
+/*!
+* \brief AR Miner Script
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This class contains the basic logic for the ore miners used in Apocalypse Rising and supports both
+* AI and player controlled miners. A miner can collect ore from any ore fields defined by a script
+* zone with the dp88_AR_Ore_Field_Zone script attached to it, which determines the value of each ore
+* 'unit' in that field, thus implicitly supporting gem fields with the same scripts.
+*
+* The miner can hold up to a configurable number of ore units, each of which takes a configurable
+* amount of time to mine from the ore field. Mining is achieved by remaining inside an ore field
+* whilst ore units are 'collected'.
+*
+* Miners can deposit ore at any time as long as they have at least one unit mined, with the total
+* value of the deposit being based on the number of units collected and the value of each unit. Ore
+* deposits are achieved by entering a script zone with the dp88_AR_Ore_Deposit_Zone attached to it
+* with the team parameter matching that of the miner.
+*
+* When the AI is enabled the miner will use the pathfind grid to locate the nearest ore field and
+* drive to it to begin mining. Once it has collected a full load of ore it will locate the nearest
+* ore deposit zone and drive there to unload it's ore. This will be repeated ad-infinitum until the
+* miner is destroyed. If you have problems with the miner getting stuck on terrain or other objects
+* you should place pathfind blockers around the problematic areas and re-generate pathfind data to
+* make it route around those locations.
+*
+* \param enableAI
+*   Specifies that this miner should use its AI to mine autonomously. 1 to enable AI, 0 otherwise
+* \param loadLevels
+*   Specifies the total number of ore units this miner can hold at any time
+* \param orePerLoadLevel
+*   Amount of ore mined in each unit, this is multiplied by the oreValue parameter in the script
+*   attached to the ore field to calculate the credit value of each ore unit
+* \param timePerLoadLevel
+*   The amount of time, in seconds, it takes to mine one ore unit from an ore field
+* \param unloadtime
+*   The amount of time, in seconds, it takes to unload all ore units at an ore deposit zone
+* \param aiStartDelay
+*   If the miner AI is enabled this specifies the initial delay before starting the first AI action,
+*   which is required to avoid the original Renegade Harvester AI overriding this one.
+* \param dockAnimation
+*   An optional animation to be played when depositing ore at a refinery
+* \param dockSound
+*   An optional sound effect to be played when depositing ore at a refinery
+* \param miningAnimation
+*   An optional animation to be played in a loop whilst mining in an ore field
+* \param miningSound
+*   An optional sound effect to be played each time the ore load level increases
+*
+* \note
+*   Because this script is designed to act as a base class for both types of AR miner it is not
+*   named after either teams miner and does not appear as an available script in LevelEdit. However,
+*   because there is no additional logic required for the Soviet War Miner there isn't actually a
+*   derived script for that at this time, thus the dp88_AR_War_Miner script in LevelEdit is really
+*   an instance of this base class script.
+*/
 
 class dp88_AR_Miner : public JFW_Key_Hook_Base	// Inherit from keyhook base for chrono miner
 {
@@ -199,6 +250,7 @@
 	int oreValue;
 
 	bool useAI;				// Is AI enabled?
+	bool animating;         // Used to identify if the harvest animation is running so it doesn't start it a second time
 	int aiState;			// Current AI state
 
 public:
@@ -332,6 +384,9 @@
 
 
 /*!
+* \brief Remote Control Vehicle Console
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
 * This script is attached to consoles to allow players to take remote control of a drone vehicle
 * which is spawned by the console on demand. The vehicle preset which is spawned must have the
 * dp88_RemoteControlVehicle script attached with a matching remoteControlID parameter to work
@@ -385,11 +440,11 @@
 class dp88_RemoteControlConsole : public ScriptImpClass
 {
 	void Created( GameObject *obj );
+  void Detach ( GameObject* obj );
 	void Poked ( GameObject *obj, GameObject *poker );
 	void Custom( GameObject *obj, int type, int param, GameObject *sender );
 	void Timer_Expired( GameObject *obj, int number );
 	void SetEnabled ( GameObject* obj, bool state );
-	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	int vehicleID;
 	int pilotID;
@@ -397,12 +452,15 @@
 	Vector3 pilotDummyPos;
 	bool m_bEnabled;
 	int m_nChargeTime;
-	int animstate;
-
 	void CreateDummy ( GameObject* pilot, Vector3 position, float facing );
 	void DestroyDummy();
 
 	void HandleDriverExit ( GameObject* obj, GameObject* pilot, GameObject* vehicle );
+
+protected:
+  LoopedAnimationController* m_pLoopedAnimCtrl;
+public:
+  dp88_RemoteControlConsole() : m_pLoopedAnimCtrl(0) {}
 };
 
 
@@ -548,8 +606,36 @@
 	void SendEndAssistanceNotifications(GameObject* obj);
 };
 
+// -------------------------------------------------------------------------------------------------
 
-// Script to link health / armour values of two objects together
+/*!
+* \brief Object health linking script
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This is a simple script that links together the health and armour states of two different objects,
+* keeping them in constant sync. This is useful when an ingame entity is made up of two seperate
+* game objects, such as the AI controlled War Miner in Apocalypse Rising which spawns a seperate
+* gun turret to allow the logic for the turret and the miner to execute on seperate objects and
+* avoid conflicts between the attack and move-to actions.
+*
+* The script works on a parent/child basis, whereby the object this script is attached to is the
+* child and the parent is the object whose ID is specified in the script parameters. Upon creation
+* the script will inherit the maximum and current values of the parents health and armour states,
+* however it will maintain it's own skin and armour types, thus allowing for a child object to be
+* either more or less resistant to damage than it's parent, allowing the creation of strong or weak
+* points in the overall entities defences.
+*
+* This script is usually attached to dynamically created objects by other scripts and it's unlikely
+* to be attached to anything directly via LevelEdit.
+*
+* \param parentObjectId
+*   ID of the parent game object with which this objects health and armour will be linked
+*
+* \note
+*   You can link multiple child objects to a single parent object to create complex entities which
+*   consist of many parts, but you should always ensure the same object is designated as the parent
+*   to avoid conflicts between the scripts.
+*/
 class dp88_linkHealth : public ScriptImpClass
 {
 	void Created ( GameObject *obj );
@@ -562,6 +648,8 @@
 	float lastArmour;
 };
 
+// -------------------------------------------------------------------------------------------------
+
 
 
 
diff -uwr sourceold/scripts/dp88_ar_unitScripts.cpp source/scripts/dp88_ar_unitScripts.cpp
--- sourceold/scripts/dp88_ar_unitScripts.cpp	2012-02-02 17:58:48.974609300 +0800
+++ source/scripts/dp88_ar_unitScripts.cpp	2012-04-24 12:35:28.803710900 +0800
@@ -30,7 +30,7 @@
 	isDead = false;
 	lastDeploy = 0;
 
-	if ( Is_Soldier ( obj ) && Get_Player_ID ( obj ) >= 0 )
+	if ( obj->As_SoldierGameObj() && Get_Player_ID ( obj ) >= 0 )
 		InstallHook( Get_Parameter("Keyhook"), obj );
 	else
 		Destroy_Script();
diff -uwr sourceold/scripts/dp88_buildingScripts.cpp source/scripts/dp88_buildingScripts.cpp
--- sourceold/scripts/dp88_buildingScripts.cpp	2012-02-23 12:06:21.652343700 +0800
+++ source/scripts/dp88_buildingScripts.cpp	2012-05-23 10:20:24.692382800 +0800
@@ -19,9 +19,11 @@
 #include "BaseControllerClass.h"
 #include "WarFactoryGameObj.h"
 #include "AirFactoryGameObj.h"
+#include "NavalFactoryGameObj.h"
 #include "RefineryGameObj.h"
 #include "PurchaseSettingsDefClass.h"
 #include "PhysicalGameObj.h"
+#include "ArmorWarheadManager.h"
 
 /*------------------------
 Building Controller Script
@@ -100,7 +102,8 @@
 	{
 		// Get ID of child
 		int childId = Commands->Get_ID ( sender );
-
+		if (findChild(childId) == -1)
+		{
 		// Does child array exist?
 		if ( children != NULL )
 		{
@@ -128,6 +131,7 @@
 			children[0].type = param;
 		}
 	}
+	}
 
 
 
@@ -548,25 +552,11 @@
 Base Class For Generic Weakpoints
 --------------------------*/
 
-void MinorWeakpointScriptClass::Animation_Complete ( GameObject *obj, const char *animation_name )
-{
-	if (animstate == 0 && Get_Int_Parameter("animLoop"))
-	{
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
-	}
-	if (animstate == 1 && Get_Int_Parameter("destroyedAnimLoop"))
-	{
-		obj->As_PhysicalGameObj()->Clear_Animation();
-		Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), false, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
-	}
-}
-
 void MinorWeakpointScriptClass::Created ( GameObject *obj )
 {
 	// Set variables
 	isDestroyed = false;
-
+	m_pLoopedAnimCtrl = NULL;
 	// Find parent
 	GameObject* parent = Find_Object_By_Preset ( Get_Object_Type ( obj ), Get_Parameter("buildingControllerPreset") );
 	if ( parent != NULL )
@@ -575,12 +565,11 @@
 
 		// Send with 1 second delay to ensure parent has been initialized
 		Commands->Send_Custom_Event ( obj, parent, CUSTOM_BUILDINGSCRIPTS_REGISTERCHILD, BUILDING_CHILD_TYPE_MINOR_WEAKPOINT, 1.0f );
-
+		m_pLoopedAnimCtrl = new LoopedAnimationController(obj);
 		// Set animation
 		if ( strlen(Get_Parameter("animName")) > 0 )
 		{
-			animstate = 0;
-			Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
+			m_pLoopedAnimCtrl->PlayAnimation(Get_Parameter("animName"),Get_Int_Parameter("animStartFrame"),Get_Int_Parameter("animEndFrame"),!Get_Int_Parameter("animLoop"));
 		}
 	}
 	else
@@ -609,8 +598,11 @@
 		// Set animation
 		if ( strlen(Get_Parameter("destroyedAnimName")) > 0 )
 		{
-			animstate = 1;
-			Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), false, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
+			m_pLoopedAnimCtrl->PlayAnimation(Get_Parameter("destroyedAnimName"),Get_Int_Parameter("destroyedAnimStartFrame"),Get_Int_Parameter("destroyedAnimEndFrame"),!Get_Int_Parameter("destroyedAnimLoop"));
+		}
+		else
+		{
+			m_pLoopedAnimCtrl->StopAnimation();
 		}
 	}
 
@@ -631,8 +623,11 @@
 		// Set animation
 		if ( strlen(Get_Parameter("animName")) > 0 )
 		{
-			animstate = 0;
-			Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
+			m_pLoopedAnimCtrl->PlayAnimation(Get_Parameter("animName"),Get_Int_Parameter("animStartFrame"),Get_Int_Parameter("animEndFrame"),!Get_Int_Parameter("animLoop"));
+		}
+		else
+		{
+			m_pLoopedAnimCtrl->StopAnimation();
 		}
 	}
 }
@@ -667,6 +662,13 @@
 		reverseEffect ( obj, parent );
 }
 
+void MinorWeakpointScriptClass::Detach ( GameObject *obj )
+{
+	if (m_pLoopedAnimCtrl)
+	{
+		delete m_pLoopedAnimCtrl;
+	}
+}
 
 
 
@@ -734,6 +736,27 @@
 	}
 }
 
+/*------------------------
+Weakpoint - Disable Naval Vehicle Purchase
+--------------------------*/
+
+void dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase::applyEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_NavalFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_NavalFactoryGameObj()->Set_Disabled(true);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(true);
+	}
+}
+
+void dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase::reverseEffect ( GameObject* obj, GameObject* parent )
+{
+	if (parent->As_BuildingGameObj() && parent->As_BuildingGameObj()->As_NavalFactoryGameObj())
+	{
+		parent->As_BuildingGameObj()->As_NavalFactoryGameObj()->Set_Disabled(false);
+		PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(parent)))->Set_Page_Disabled(false);
+	}
+}
 
 /*------------------------
 Weakpoint - Disable Base Power
@@ -817,12 +840,12 @@
 
 void dp88_buildingScripts_functionMoneyTrickle::Created ( GameObject *obj )
 {
+	isTimerRunning = false;
 	if ( Get_Object_Type(obj) == 0 || Get_Object_Type(obj) == 1 )
 	{
 		isTimerRunning = true;
 		Commands->Start_Timer(obj, this, 0.1f, TIMER_BUILDINGSCRIPTS_TRICKLEMONEY );
 	}
-	isTimerRunning = false;
 }
 
 void dp88_buildingScripts_functionMoneyTrickle::OnBuildingCaptured ( GameObject *obj, int team )
@@ -856,6 +879,38 @@
 }
 
 
+void dp88_buildingScripts_functionMoneyGrant::Created ( GameObject *obj )
+{
+	if ( Get_Object_Type(obj) == 0 || Get_Object_Type(obj) == 1 )
+	{
+		int team = Get_Object_Type(obj);
+		GameObject* pFirstPlayer = Find_First_Player(team);
+		if ( pFirstPlayer )
+		{
+			Commands->Give_Money(pFirstPlayer,Get_Float_Parameter("credits"),true);
+		}
+		if (Get_Int_Parameter("onceOnly") == 1)
+		{
+			Destroy_Script();
+		}
+	}
+}
+
+void dp88_buildingScripts_functionMoneyGrant::OnBuildingCaptured ( GameObject *obj, int team )
+{
+	if (team == 0 || team == 1)
+	{
+		GameObject* pFirstPlayer = Find_First_Player(team);
+		if ( pFirstPlayer )
+		{
+			Commands->Give_Money(pFirstPlayer,Get_Float_Parameter("credits"),true);
+		}
+		if (Get_Int_Parameter("onceOnly") == 1)
+		{
+			Destroy_Script();
+		}
+	}
+}
 
 
 /*------------------------
@@ -1064,7 +1119,7 @@
 
 		// Check parent is not a building (since changing the team of a BuildingGameObj results
 		// in some very strange behaviour that we really don't want)
-		if ( Is_Building(parent) )
+		if ( parent->As_BuildingGameObj() )
 		{
 			Console_Output ( "[%d:%s:%s] Critical Error: Building controller '%s' is of type BuildingGameObj, capturing is not possible. Destroying script...\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 			Destroy_Script();
@@ -1095,14 +1150,18 @@
 }
 
 
+extern REF_DECL2(NodHouseColor, Vector3);
+extern REF_DECL2(GDIHouseColor, Vector3);
+extern REF_DECL2(PublicMessageColor, Vector3);
 void dp88_buildingScripts_capturePoint::Damaged( GameObject *obj, GameObject *damager, float amount )
 {
 	float health = Commands->Get_Health(obj);
 	float max = Commands->Get_Max_Health(obj);
 
-	// If the damager was on the Soviet team then decrease the health by 1 and
+	// If the damager was the soviet engineer then decrease the health by 1 and
 	// check if they have now captured the building
-	if ( Get_Object_Type(damager) == 0 )
+	unsigned int warhead = ArmorWarheadManager::Get_Warhead_Type(Get_Parameter("warhead"));
+	if (warhead == Get_Damage_Warhead() && Commands->Get_Player_Type(damager) == 0)
 	{
 		// Decrease health by 1.00 (unless we are already below 1.25 in which
 		// case we just set it to 0.25)
@@ -1113,6 +1172,33 @@
 		if ( health == 0.25f && currentTeam != 0 )
 		{
 			currentTeam = 0;
+			int red = (int)(NodHouseColor.X * 255);
+			int green = (int)(NodHouseColor.Y * 255);
+			int blue = (int)(NodHouseColor.Z * 255);
+			int stringall = Get_Int_Parameter("Sov_String_All");
+			if (stringall && Is_Valid_String_ID(stringall))
+			{
+				const char *str = Get_Translated_String(stringall);
+				Send_Message_Team(1,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringall);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+				}
+			}
+			int stringsov = Get_Int_Parameter("Sov_String_Sov");
+			if (stringsov && Is_Valid_String_ID(stringsov))
+			{
+				const char *str = Get_Translated_String(stringsov);
+				Send_Message_Team(0,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringsov);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+				}
+			}
 			Commands->Send_Custom_Event (obj, Commands->Find_Object(parentId), CUSTOM_BUILDINGSCRIPTS_BUILDINGCAPTURED, currentTeam, 0.0f );
 			Set_Object_Type(obj,currentTeam);
 		}
@@ -1120,6 +1206,33 @@
 		// OK, we didn't capture it, but did we manage to make it neutral?
 		else if ( currentTeam == 1 && health <= max/2.0f )
 		{
+			int red = (int)(PublicMessageColor.X * 255);
+			int green = (int)(PublicMessageColor.Y * 255);
+			int blue = (int)(PublicMessageColor.Z * 255);
+			int stringall = Get_Int_Parameter("Neutral_String_All");
+			if (stringall && Is_Valid_String_ID(stringall))
+			{
+				const char *str = Get_Translated_String(stringall);
+				Send_Message_Team(1,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringall);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+				}
+			}
+			int stringsov = Get_Int_Parameter("Neutral_String_Sov");
+			if (stringsov && Is_Valid_String_ID(stringsov))
+			{
+				const char *str = Get_Translated_String(stringsov);
+				Send_Message_Team(0,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringsov);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+				}
+			}
 			currentTeam = -2;
 			Commands->Send_Custom_Event (obj, Commands->Find_Object(parentId), CUSTOM_BUILDINGSCRIPTS_BUILDINGCAPTURED, currentTeam, 0.0f );
 			Set_Object_Type(obj,currentTeam);
@@ -1127,9 +1240,9 @@
 	}
 
 
-	// If the damager was on the Soviet team then increase the health by 1 and
+	// If the damager was the allied engineer then increase the health by 1 and
 	// check if they have now captured the building
-	else if ( Get_Object_Type(damager) == 1 )
+	else if (warhead == Get_Damage_Warhead() && Commands->Get_Player_Type(damager) == 1)
 	{
 		// Increase health by 1.00 (unless we are already less than 1.00 below the
 		// maximum in which case we just set it to the maximum)
@@ -1140,6 +1253,33 @@
 		if ( health == max && currentTeam != 1 )
 		{
 			currentTeam = 1;
+			int red = (int)(GDIHouseColor.X * 255);
+			int green = (int)(GDIHouseColor.Y * 255);
+			int blue = (int)(GDIHouseColor.Z * 255);
+			int stringall = Get_Int_Parameter("All_String_All");
+			if (stringall && Is_Valid_String_ID(stringall))
+			{
+				const char *str = Get_Translated_String(stringall);
+				Send_Message_Team(1,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringall);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+				}
+			}
+			int stringsov = Get_Int_Parameter("All_String_Sov");
+			if (stringsov && Is_Valid_String_ID(stringsov))
+			{
+				const char *str = Get_Translated_String(stringsov);
+				Send_Message_Team(0,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringsov);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+				}
+			}
 			Commands->Send_Custom_Event (obj, Commands->Find_Object(parentId), CUSTOM_BUILDINGSCRIPTS_BUILDINGCAPTURED, currentTeam, 0.0f );
 			Set_Object_Type(obj,currentTeam);
 		}
@@ -1147,6 +1287,33 @@
 		// OK, we didn't capture it, but did we manage to make it neutral?
 		else if ( currentTeam == 0 && health >= max/2.0f )
 		{
+			int red = (int)(PublicMessageColor.X * 255);
+			int green = (int)(PublicMessageColor.Y * 255);
+			int blue = (int)(PublicMessageColor.Z * 255);
+			int stringall = Get_Int_Parameter("Neutral_String_All");
+			if (stringall && Is_Valid_String_ID(stringall))
+			{
+				const char *str = Get_Translated_String(stringall);
+				Send_Message_Team(1,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringall);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),1);
+				}
+			}
+			int stringsov = Get_Int_Parameter("Neutral_String_Sov");
+			if (stringsov && Is_Valid_String_ID(stringsov))
+			{
+				const char *str = Get_Translated_String(stringsov);
+				Send_Message_Team(0,red,green,blue,str);
+				delete[] str;
+				int soundId = Get_String_Sound_ID(stringsov);
+				if (soundId && Is_Valid_Preset_ID(soundId) && Find_Definition(soundId)->Get_Class_ID() == 0x5000)
+				{
+					Create_2D_Sound_Team(Get_Definition_Name(soundId),0);
+				}
+			}
 			currentTeam = -2;
 			Commands->Send_Custom_Event (obj, Commands->Find_Object(parentId), CUSTOM_BUILDINGSCRIPTS_BUILDINGCAPTURED, currentTeam, 0.0f );
 			Set_Object_Type(obj,currentTeam);
@@ -1300,11 +1467,84 @@
 	partObjectId = NULL;
 }
 
+// -------------------------------------------------------------------------------------------------
+
+void dp88_buildingScripts_PT_Script::Created( GameObject *obj )
+{
+  m_pLoopedAnimCtrl = NULL;
+
+	// Find parent
+	GameObject* parent = Find_Object_By_Preset ( Get_Object_Type ( obj ), Get_Parameter("buildingControllerPreset") );
+	if ( parent != NULL )
+	{
+		parentId = Commands->Get_ID ( parent );
+
+		// Send with 1 second delay to ensure parent has been initialized
+		Commands->Send_Custom_Event ( obj, parent, CUSTOM_BUILDINGSCRIPTS_REGISTERCHILD, BUILDING_CHILD_TYPE_GENERIC, 1.0f );
+		Commands->Start_Timer(obj, this, 1.0f, TIMER_CHECK_BASE_POWER_STATE );
+		dead = false;
+		basePowerState = Is_Base_Powered(Get_Object_Type(obj));
+	    m_pLoopedAnimCtrl = new LoopedAnimationController(obj);
+		SetDamageAnimation(obj);
+	}
+	else
+	{
+		Console_Output ( "[%d:%s:%s] Critical Error: Building controller '%s' not found. Destroying script...\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Parameter("buildingControllerPreset") );
+		Destroy_Script();
+	}
+}
+
+void dp88_buildingScripts_PT_Script::Detach ( GameObject *obj )
+{
+	if (m_pLoopedAnimCtrl)
+	{
+		delete m_pLoopedAnimCtrl;
+	}
+}
+
+void dp88_buildingScripts_PT_Script::Custom( GameObject *obj, int type, int param, GameObject *sender )
+{
+	if ( type == CUSTOM_BUILDINGSCRIPTS_BUILDINGDESTROYED && Commands->Get_ID(sender) == parentId )
+	{
+		parentId = -1;
+		dead = true;
+		SetDamageAnimation(obj);
+	}
+}
 
+void dp88_buildingScripts_PT_Script::SetDamageAnimation ( GameObject* obj )
+{
+  int sFrame = 0;
+  int eFrame = 0;
 
+  if (basePowerState)
+  {
+    sFrame = (int)((dead) ? Get_Float_Parameter("DeadAnimationStartFrame") : Get_Float_Parameter("AliveAnimationStartFrame"));
+    eFrame = (int)((dead) ? Get_Float_Parameter("DeadAnimationEndFrame") : Get_Float_Parameter("AliveAnimationEndFrame"));
+  }
+  else
+  {
+    sFrame = (int)((dead) ? Get_Float_Parameter("LPDeadAnimationStartFrame") : Get_Float_Parameter("LPAliveAnimationStartFrame"));
+    eFrame = (int)((dead) ? Get_Float_Parameter("LPDeadAnimationEndFrame") : Get_Float_Parameter("LPAliveAnimationEndFrame"));
+  }
 
+  m_pLoopedAnimCtrl->PlayAnimation ( Get_Parameter("Animation"), sFrame, eFrame );
+}
 
+void dp88_buildingScripts_PT_Script::Timer_Expired ( GameObject* obj, int number )
+{
+	if ( number == TIMER_CHECK_BASE_POWER_STATE )
+	{
+		if ( Is_Base_Powered(Get_Object_Type(obj)) != basePowerState )
+		{
+			basePowerState = !basePowerState;
+			SetDamageAnimation(obj);
+		}
 
+		// Restart timer
+		Commands->Start_Timer(obj, this, 1.0f, TIMER_CHECK_BASE_POWER_STATE );
+	}
+}
 
 ScriptRegistrant<dp88_buildingScripts_buildingController> dp88_buildingScripts_buildingController_Registrant( "dp88_buildingScripts_buildingController", "team0_buildingOfflineStringId=0:int,team1_buildingOfflineStringId=0:int,team0_buildingOnlineStringId=0:int,team1_buildingOnlineStringId=0:int" );
 
@@ -1315,15 +1555,18 @@
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableSoldierPurchase> dp88_buildingScripts_weakpoint_disableSoldierPurchase_Registrant( "dp88_buildingScripts_weakpoint_disableSoldierPurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableVehiclePurchase> dp88_buildingScripts_weakpoint_disableVehiclePurchase_Registrant( "dp88_buildingScripts_weakpoint_disableVehiclePurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableAirVehiclePurchase> dp88_buildingScripts_weakpoint_disableAirVehiclePurchase_Registrant( "dp88_buildingScripts_weakpoint_disableAirVehiclePurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
+ScriptRegistrant<dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase> dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase_Registrant( "dp88_buildingScripts_weakpoint_disableNavalVehiclePurchase", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableBasePower> dp88_buildingScripts_weakpoint_disableBasePower_Registrant( "dp88_buildingScripts_weakpoint_disableBasePower", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableRadar> dp88_buildingScripts_weakpoint_disableRadar_Registrant( "dp88_buildingScripts_weakpoint_disableRadar", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 ScriptRegistrant<dp88_buildingScripts_weakpoint_disableRefinery> dp88_buildingScripts_weakpoint_disableRefinery_Registrant( "dp88_buildingScripts_weakpoint_disableRefinery", "buildingControllerPreset:string,animName:string,animStartFrame=0:int,animEndFrame=0:int,animLoop=0:int,destroyedAnimName:string,destroyedAnimStartFrame=0:int,destroyedAnimEndFrame=0:int,destroyedAnimLoop=0:int" );
 
 ScriptRegistrant<dp88_buildingScripts_functionMoneyTrickle> dp88_buildingScripts_functionMoneyTrickle_Registrant( "dp88_buildingScripts_functionMoneyTrickle", "creditsPerSec=3.0:float" );
 ScriptRegistrant<dp88_buildingScripts_functionSpawnTeamZone> dp88_buildingScripts_functionSpawnTeamZone_Registrant( "dp88_buildingScripts_functionSpawnTeamZone", "scriptZonePreset_team0:string,scriptZonePreset_team1:string,scriptZonePreset_team2:string,scriptZoneBone:string,scriptZoneSize:vector3,destroyZoneWhenDisabled=1:int" );
+ScriptRegistrant<dp88_buildingScripts_functionMoneyGrant> dp88_buildingScripts_functionMoneyGrant_Registrant( "dp88_buildingScripts_functionMoneyGrant", "credits:float,onceOnly=1:int");
 
 ScriptRegistrant<dp88_buildingScripts_scriptZone> dp88_buildingScripts_scriptZone_Registrant( "dp88_buildingScripts_scriptZone", "buildingControllerPreset:string,scriptZonePreset:string,scriptZoneSize:vector3,destroyZoneWhenDisabled=1:int,destroyZoneWhenDestroyed=1:int" );
 
-ScriptRegistrant<dp88_buildingScripts_capturePoint> dp88_buildingScripts_capturePoint_Registrant( "dp88_buildingScripts_capturePoint", "buildingControllerPreset:string,dead_preset=null:string" );
+ScriptRegistrant<dp88_buildingScripts_capturePoint> dp88_buildingScripts_capturePoint_Registrant( "dp88_buildingScripts_capturePoint", "buildingControllerPreset:string,dead_preset=null:string,warhead:string,All_String_All:int,Sov_String_All:int,Neutral_String_All:int,All_String_Sov:int,Sov_String_Sov:int,Neutral_String_Sov:int");
 
 ScriptRegistrant<dp88_buildingScripts_spawnPart> dp88_buildingScripts_spawnPart_Registrant("dp88_buildingScripts_spawnPart","Building_Part_Preset:string,Spawn_At_Bone:string,IsDecorative=0:int");
\ No newline at end of file
+ScriptRegistrant<dp88_buildingScripts_PT_Script> dp88_buildingScripts_PT_Script_Registrant( "dp88_buildingScripts_PT_Script", "buildingControllerPreset:string,Animation:string,AliveAnimationStartFrame:float,AliveAnimationEndFrame:float,DeadAnimationStartFrame:float,DeadAnimationEndFrame:float,LPAliveAnimationStartFrame:float,LPAliveAnimationEndFrame:float,LPDeadAnimationStartFrame:float,LPDeadAnimationEndFrame:float");
